/*
 * COPYRIGHT (c) International Business Machines Corp. 2023
 *
 * This program is provided under the terms of the Common Public License,
 * version 1.0 (CPL-1.0). Any use, reproduction or distribution for this
 * software constitutes recipient's acceptance of CPL-1.0 terms which can be
 * found in the file LICENSE file or at
 * https://opensource.org/licenses/cpl1.0.php
 */
/* AUTO-GENERATED on Wed Apr  5 19:52:27 2023.  DO NOT EDIT! */

#include <string.h>
#include <pkcs11types.h>
#include "mechtable.h"
#include "mechtable.inc"

static const unsigned char numericalphabet[] = {
  0, 1, 2, 3, 4, 5, 6, 7,
  0, 8, 9, 10, 11, 12, 13, 0,
  14, 15, 16, 0, 0, 0, 0, 0,
  0, 0, 0, 17, 18, 0, 19, 20,
  21, 22, 23, 24, 25, 26, 27, 28,
  29, 0, 0, 0, 0, 0, 0, 0,
  30, 31, 32, 33, 34, 35, 36, 37,
  38, 0, 0, 0, 0, 0, 0, 0,
  39, 40, 41, 42, 43, 44, 45, 46,
  47, 48, 49, 0, 50, 51, 52, 0,
  53, 54, 55, 56, 0, 57, 58, 59,
  0, 0, 0, 0, 0, 0, 0, 0,
  60, 61, 62, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  63, 64, 65, 0, 0, 0, 66, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  67, 68, 69, 70, 71, 72, 73, 74,
  0, 75, 76, 0, 0, 0, 0, 0,
  0, 0, 77, 78, 79, 80, 81, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  82, 0, 0, 0, 0, 0, 0, 0,
  83, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
};
static const short numerictable[] = {
  -71, -70, 149, -74, 3, -68, -81, -47,
  -72, -76, -75, -83, -73, -82, -35, -34,
  -37, 30, 4, -36, -33, -32, -31, 24,
  28, -65, -66, -67, 2, -48, 110, 0,
  -77, -78, -79, 0, 0, 0, 0, -94,
  -100, -112, -95, -101, -113, -88, -89, -103,
  -104, -105, -106, -107, -108, -45, -39, -40,
  -41, -42, -43, -44, 0, 0, 0, 0,
  -90, -91, -92, -38, -84, -85, -86, -96,
  -97, -98, -102, -109, -110, 0, 0, 0,
  0, -11, -9, -1, -12, -13, -2, -8,
  -10, -7, -6, -29, -28, -24, 0, 16,
  -25, 0, 0, 0, -15, -21, -20, -16,
  -22, -23, -17, -19, -18, 0, 0, -57,
  -59, -61, -63, 0, 0, -49, -14, -4,
  -5, -3, -120, -30, 0, -26, -27, -52,
  -54, -53, -55, 0, -46, 0, -50, -56,
  -58, -60, -62, -64, 0, -51, -117, -115,
  -114, -119, -116, -118, 0, 0, 70, 11,
  79, 0, 0, 0, -80, -93, -99, -111,
  -87, -69, -121, 14, 0, 0, 0, 0,
  0, 0, 19, 114, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0,
};
int mechtable_idx_from_numeric(CK_ULONG mech)
{
    unsigned int idx1, idx2, idx3, idx4;
    int o1, o2, o3;
    int midx;

    idx1 = numericalphabet[(mech & 0xff000000u) >> 24u];
    idx2 = numericalphabet[(mech & 0x00ff0000u) >> 16u];
    idx3 = numericalphabet[(mech & 0x0000ff00u) >> 8u];
    idx4 = numericalphabet[mech & 0x000000ffu];
    o1 = numerictable[28 + idx1];
    if (o1 < 0) return -1;
    o2 = numerictable[o1 + idx2];
    if (o2 < 0) return -1;
    o3 = numerictable[o2 + idx3];
    if (o3 < 0) return -1;
    midx = numerictable[o3 + idx4];
    midx = -(midx + 1);
    if (0 <= midx && midx < 121 && mechtable_rows[midx].numeric == mech)
        return midx;
    return -1;
}

const struct mechrow *mechrow_from_numeric(CK_ULONG mech)
{
    int idx = mechtable_idx_from_numeric(mech);

    if (idx < 0)
        return NULL;
    return &mechtable_rows[idx];
}

static const unsigned char stringalphabet[] = {
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  1, 2, 3, 4, 5, 6, 7, 0,
  8, 9, 0, 0, 0, 0, 0, 0,
  0, 10, 11, 12, 13, 14, 15, 16,
  17, 18, 0, 19, 20, 21, 22, 23,
  24, 0, 25, 26, 27, 28, 29, 30,
  31, 32, 0, 0, 0, 0, 0, 33,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
};
static const short stringtable[] = {
  0, 0, 196, 88, 262, -52, 284, -53,
  28, 192, 9, 201, 133, 3, 163, 143,
  -46, 115, 171, 149, 133, 193, 137, 45,
  314, 186, 62, -119, 36, 164, -9, 191,
  -10, 221, 191, 307, 90, 128, 196, -14,
  -47, -48, -49, -50, 69, 104, 1, 119,
  -20, -56, 282, 122, -111, -21, 217, 141,
  173, 124, 281, -15, 110, -83, 4, -8,
  -28, -34, -40, 178, -43, -29, -44, 97,
  221, -30, -87, 236, 251, -93, -99, 212,
  221, 94, 186, 236, 251, -114, -39, 310,
  296, 50, -117, 236, -118, 284, 249, -3,
  289, -31, 80, -35, -4, -5, 88, -32,
  -36, -38, -37, -51, -33, -65, 187, -70,
  -71, 185, 166, -77, -72, -73, -68, 151,
  -80, -84, -45, -90, -96, -102, 205, 157,
  -103, -106, 16, 132, -1, 93, 123, 136,
  -6, -74, 127, 140, -12, 56, 93, 34,
  93, 146, -16, 137, 207, 150, -18, 140,
  153, -22, 55, 159, 58, 59, 33, -24,
  156, 273, 280, -26, -27, -2, 143, 149,
  158, -7, 145, 139, 84, -13, 65, 89,
  86, 161, 170, -17, 64, -41, 164, -19,
  -42, 154, -23, 30, 2, -54, 183, -55,
  -25, 190, 162, 5, 197, -57, 199, -59,
  196, 202, -61, 201, 205, -63, 201, 109,
  199, 198, 211, -66, 203, 181, 14, 204,
  191, 111, 215, 218, 221, -75, 0, 115,
  204, 216, 215, 228, -78, 101, -58, 223,
  -60, 201, 30, -62, 225, 213, -64, 240,
  -81, 121, 233, 233, -67, 246, -85, 238,
  216, 226, 232, 240, 227, 255, -76, -88,
  123, 248, 247, 260, -91, -79, 253, 231,
  241, 247, 255, 242, 269, -94, 266, 124,
  264, -82, 263, 276, -97, 268, 247, -86,
  257, 263, 271, 258, 285, -100, 284, 125,
  -89, 128, 270, 282, 282, -92, 295, -104,
  129, 277, 289, 288, 301, -107, -95, 294,
  293, 306, -109, 298, 277, -98, 287, 293,
  301, 288, 315, -112, 313, 286, -101, 66,
  -115, 290, 291, -116, 310, -69, -11, 0,
  -105, 0, 0, 0, 0, -121, -108, 0,
  0, 0, 0, -110, -120, 0, 0, 0,
  0, 0, 0, 0, -113,
};
static const size_t commonprefixlength = 4;

int mechtable_idx_from_string(const char *mech)
{
    static const struct {
        const char *string;
        const char *alias;
    } aliaslist[] = {
        { "CKM_ECDSA_KEY_PAIR_GEN", "CKM_EC_KEY_PAIR_GEN" },
        { "CKM_IBM_EC_C25519", "CKM_IBM_EC_X25519" },
        { "CKM_IBM_EC_C448", "CKM_IBM_EC_X448" },
        { "CKM_IBM_EDDSA_SHA512", "CKM_IBM_ED25519_SHA512" },
    };
    size_t len = strlen(mech), i;
    short idx = 0;
    unsigned char h;

    for (i = commonprefixlength; i <= len; ++i) {
        h = stringalphabet[(int)mech[i]];
        idx = stringtable[idx + h];
        if (idx < 0) {
            idx = -(idx + 1);
            if (strcmp(mech, mechtable_rows[idx].string) == 0)
                return idx;
            goto outcheckaliases;
        }
    }
  outcheckaliases:
    for (i = 0; i < sizeof(aliaslist) / sizeof(aliaslist[0]); ++i) {
        if (strcmp(aliaslist[i].string, mech) == 0)
            return mechtable_idx_from_string(aliaslist[i].alias);
    }
    return -1;
}

const struct mechrow *mechrow_from_string(const char *mech)
{
    int idx = mechtable_idx_from_string(mech);

    if (idx < 0)
        return NULL;
    return &mechtable_rows[idx];
}

const struct mechtable_funcs mechtable_funcs = {
    .p_idx_from_num = &mechtable_idx_from_numeric,
    .p_idx_from_str = &mechtable_idx_from_string,
    .p_row_from_num = &mechrow_from_numeric,
    .p_row_from_str = &mechrow_from_string
};

